#include <windows.h>
#include <string.h>
#include <stdio.h>

// ini2reg ini file to registry program by Tarn Burton, April 1995
// This program is hereby put into the public domain

#define BUFFER_SIZE 262144
#define VALUE_SIZE 512

static wchar_t NullChar='\0';

extern "C" int wmain( int argc, wchar_t *argv[ ], wchar_t *envp[ ] ) {
	if (argc<4) {
		fwprintf(stderr,L"Incorrect number of arguments!\n");
		return -1;; };
	wchar_t *RootKeyName=wcstok(argv[2],L"\\ ");
	HKEY RootKey;
	if (_wcsicmp(RootKeyName,L"machine")==0) {
		RootKey=HKEY_LOCAL_MACHINE; } else if (_wcsicmp(RootKeyName,L"user")==0) {
		RootKey=HKEY_CURRENT_USER; } else {
		fwprintf(stderr,L"Unknown registry root key:  %s\n",RootKeyName);
		return -1;; };
	RootKeyName=wcstok(NULL,L"");
	if (RootKeyName[0]=='\\') RootKeyName++;
	DWORD Result;
	if (RegCreateKeyEx(RootKey,RootKeyName,0,NULL,REG_OPTION_NON_VOLATILE,KEY_WRITE,NULL,&RootKey,&Result)!=ERROR_SUCCESS) {
		fwprintf(stderr,L"Unable to create registry key:  %s\n",RootKeyName);
		return -1;; };
	int i;
	HKEY SectionKey;
	LPTSTR SectionBuffer=new wchar_t[BUFFER_SIZE];
	LPTSTR CurrentEntry;
	for (i=3;i<argc;i++) {
		if (RegCreateKeyEx(RootKey,argv[i],0,NULL,REG_OPTION_NON_VOLATILE,KEY_WRITE,NULL,&SectionKey,&Result)!=ERROR_SUCCESS) {
			fwprintf(stderr,L"Unable to create registry key:  %s\\%s\n",RootKeyName,argv[i]);
			return -1;; };
		GetPrivateProfileSection(argv[i],SectionBuffer,BUFFER_SIZE,argv[1]);
		CurrentEntry=SectionBuffer;
		int l;
		LPTSTR ValueName,Value;
		while (CurrentEntry[0]!='\0') {
			l=wcslen(CurrentEntry);
			ValueName=wcstok(CurrentEntry,L"=");
			Value=wcstok(NULL,L"=");
			if (Value==NULL) Value=&NullChar;
			RegSetValueEx(SectionKey,ValueName,0,REG_SZ,(const BYTE*)Value,(wcslen(Value)+1)*sizeof(wchar_t));
			CurrentEntry+=l+1; };
		RegCloseKey(SectionKey); };
	RegCloseKey(RootKey);
	delete SectionBuffer;
	return 0; }


